# csh plotLossRate.com t10 t4 ps
# Plot the packet drop rate as a function of time.
set lossEventRate=$1
set file2=$2
awk '{print $1, $2*0.01}' < $file2 > NumLosses
set type=$3
if ($type == "ps") then 
  set type1='postscript eps'
endif
if ($type == "png") then 
  set type1='png'
endif
gnuplot << !
set terminal $type1 
set xlabel "Time"
set ylabel "Loss Event Rate"
set yrange [0:]
set title "Loss Event Rates"
set output "lossEventRates.$type"
set key right 
set size 1.0,0.8 
plot "$lossEventRate" title "Loss Event Rate" with linespoints pt 1 ps 1, \
"NumLosses" title "Number of Losses" with lines 
!
