# csh table20All.com 0.03 2 
set rate=$1
set voip=$2
# rate: packet drop rate;   
# voip: voipvariant, set to 2 (regular) or 3 (Section C variant)
#
# For simulations with a single TFRC-SP flow with a
#   configured packet drop rate, an RTT > 400 ms., and a segment
#   size of 10 bytes.
#
# The output graph shows TFRC-SP's estimated loss event rate,
#   along with the number of packet losses in each loss event,
#   for short loss events.  Long loss events are always shown with a
#   single packet loss.
#
set params='-cbrrate 8.0Kb -tfrcpktsize 10 -flows 1 -rtts 0 -delay 200'
set params1='-printFIDs 0 -printPkts 0 -tfrc 1 -tfrc-sp 1'
#
ns sims.tcl -voip $voip $params $params1 -droprate $rate > data
#
awk '{if($11=="4:"){print;}}' < data | awk -f shortints2.awk > losses
awk '{if($11=="4:"){print;}}' < data | awk -f table20.awk > data1
awk '{if($3=="loss_rate:"){print $2, $4;}}' < data > rate
csh plotLossRate.com rate losses ps
gv lossEventRates.ps &
awk -f shortints.awk < data1 
#
# data: all loss interval data
# data1: more compact form of loss intervals tables, without current interval.
# losses: number of losses in each loss interval.  1 for long loss intervals.
# rate: loss event rate
